

//////////////////////////////////////////////////////////////////
//                                                              //
//           PLINK (c) 2005-2006 Shaun Purcell                  //
//                                                              //
// This file is distributed under the GNU General Public        //
// License, Version 2.  Please see the file COPYING for more    //
// details                                                      //
//                                                              //
//////////////////////////////////////////////////////////////////


#include <iostream>
#include <string>
#include "options.h"

using namespace std;

bool   par::verbose = false;
bool   par::debug = false;
bool   par::web_check = true;
bool   par::recode = false;
bool   par::recode_12 = false;
bool   par::recode_AD = false;
bool   par::recode_AD_fixed = false;
bool   par::recode_jes = false;
bool   par::list_by_allele = false;
bool   par::merge_data = false;
int    par::merge_mode = 1;
bool   par::merge_binary = false;
bool   par::merge_list = false;
string par::merge_list_filename = "merge.list";
string par::merge_pedfile = "merge.ped";
string par::merge_mapfile = "merge.map";
string par::merge_bedfile = "merge.bed";
string par::merge_bimfile = "merge.bim";
string par::merge_famfile = "merge.fam";

bool   par::flip_strand = false;
string par::flip_file = "plink.flip";

string par::pedfile  = "plink.ped";
string par::mapfile  = "plink.map";
string par::fileroot = "plink";

bool par::SNP_major = true;
bool par::out_SNP_major = true;

string par::output_file_name = "plink";
bool par::silent = false;

string par::bitfilename = "plink.bed";
string par::bitfilename_fam = "plink.fam";
string par::bitfilename_map = "plink.bim";

bool   par::write_bitfile = false;
bool   par::read_bitfile = false;

bool par::pheno_file = false;
bool par::covar_file = false;

int par::mult_pheno = 1;
int par::mult_covar = 1;
int par::mult_clst = 1;

string par::pheno_filename = "plink.phe";
string par::covar_filename = "plink.cov";

string par::missing_genotype = "0";
string par::missing_phenotype = "-9";
bool par::ignore_missing_sex = false;

bool par::cm_map = false;
double par::grid = 0.005;
double par::fringe = .02;
bool par::singlepoint = true;
int par::inter_grid = 0;
bool par::bins = false;

bool par::done_global_pihat = false;

bool par::summ_nonfounders = false;
bool par::has_nonfounders = false;

bool par::report_missing = false;
bool par::test_missing = false;

double par::min_af = 0.01;
int par::min_geno_cell = 5;


vector<bool> par::chr_haploid;
vector<bool> par::chr_sex;
bool par::species_dog = false;
int par::run_chr = 0;
int par::run_start = 0;
int par::run_end = 0;
string par::m1 = "";
string par::m2 = "";
double par::window = 0; // kb 
bool par::position_window = false;
int par::from_window = 0; // bp 
int par::to_window = 0;   // bp 

bool par::mk_datfile = false;
bool par::qt = false;
bool par::bt = true;
bool par::coding01 = false;
bool par::ignore_phenotypes = true;
bool par::segment_output = false;
bool par::segment_output_started = false;
int par::segment_inter_snp_distance = 1000; //unit = kb
bool par::multi_output = false;
bool par::gmulti_output = false;
bool par::genome_output = false;
bool par::summary_ibd_output = false;
double par::IBD_threshold = 0.2;
double par::segment_threshold_start = 0.4;
double par::segment_threshold_finish = 0.3;
bool par::nudge = false;
bool par::bound = true;
bool par::show_impossible_IBD = true;

bool par::SD = true;
bool par::CP = false;
bool par::affpair = false;
bool par::remove_unaffected_pairs = false;
bool par::fix_prev = false;
double par::fixed_prev = 0;

bool par::sol_family = false;

string par::tagfile = "plink.tag";
string par::mapfile_impute = "plink.impute.map";
bool par::impute_tags = false;
bool par::phase_snps = false;
double par::hap_post_prob = 0.8;
double par::hap_missing_geno = 0.5;
int par::hap_max_nf_phases = 1024;
double par::hap_min_phase_prob = 0.005;
bool par::display_hap_freqs = false;
bool par::test_hap_CC = false;
bool par::test_hap_TDT = false;
bool par::display_phase_probs = false;

bool par::assoc_test = false;
bool par::assoc_test_alt_perm = false;
bool par::full_model_assoc = false;

bool par::model_perm_best = false;
bool par::model_perm_gen = false;
bool par::model_perm_dom = false;
bool par::model_perm_rec = false;
bool par::model_perm_trend = false;

bool par::assoc_gxe = false;

bool par::QTDT_test = false;
bool par::QFAM_total = false;
bool par::QFAM_between = false;
bool par::QFAM_within1 = false;
bool par::QFAM_within2 = false;

bool par::TDT_test = false;
bool par::perm_TDT_basic = true;
bool par::perm_TDT_parent = false;
bool par::discordant_parents = false;
bool par::parent_of_origin = false;
bool par::perm_POO_poo = true;
bool par::perm_POO_pat = false;
bool par::perm_POO_mat = false;
bool par::perm_POO_best = false;
bool par::built_families = false;

bool par::HWD_test = false;
bool par::HWD_report = false;
double par::HWD_limit = 0.001;
bool par::HWD_standard = false;
bool par::HWD_filter_on_all = false;

bool par::MENDEL_test = false;
bool par::MENDEL_report = false;
double par::MENDEL_ind = 0.1;
double par::MENDEL_snp = 0.1;

bool par::CMH_test_1 = false;
bool par::CMH_test_2 = false;
bool par::CMH_test_ORD = false;
bool par::breslowday = false;

bool par::OR_homog_test = false;

double par::ci_level = 0.95;
bool par::display_ci = false;

bool par::multtest = false;
bool par::use_GC = false;

bool par::ibs_sharing_test = false;

bool par::dump_set = false;
string par::dump_set_file = "plink.set";
bool par::exclude_set = false;

bool par::dump_gene = false;
string par::dump_genename = "";

bool   par::permute           = false;
int    par::replicates        = 1000;
bool   par::adaptive_perm     = true;
int    par::adaptive_min      = 5;
int    par::adaptive_max      = 1000000;
int    par::adaptive_interval = 1;
double par::adaptive_interval2= 0.001;
double par::adaptive_alpha    = 0.00;
double par::adaptive_ci       = 0.0001;

bool   par::perm_genedrop          = false;
bool   par::perm_genedrop_and_swap = false;
bool   par::perm_genedrop_unrel    = false;
bool   par::perm_genedrop_parents  = false;
bool   par::perm_genedrop_sibships = false;

bool par::hotel = false;

bool par::set_test                = false;
int par::set_min                  = -1;   
int par::set_max                  = 5;   
string par::setfile               = "plink.set";

bool par::permute_within_sol      = false;

bool par::boot                    = false;

bool par::disp_r1                 = false;
bool par::disp_r2                 = false;

bool par::prune_ld = false;
double par::prune_ld_vif = 2;
int par::prune_ld_win = 100;
int par::prune_ld_step = 50;

double par::epi_alpha1 = 0.0001;
double par::epi_alpha2 = 0.01;
bool par::epi_filter = true;
bool par::set_by_set = true;
bool par::epistasis = false;
bool par::epi_caseonly = false;
double par::epi_caseonly_kb_gap = 1000; // 1Mb default gap in SNPxSNP tests
bool par::epi_genebased = false;
double par::epi_vif = 10;
bool par::epi_quickscan = false;

bool par::inbreeding = false;
bool par::local_homozygosity = false;
double par::local_homozygosity_window = 100;
int par::local_homozygosity_step = 5;

bool par::homo_run = false;
int par::homo_run_length = 100;
bool par::homo_run_length_kb = false;
int par::homo_run_het = 1;

bool par::ibs_run = false;
int par::ibs_run_length_snps = 100;
int par::ibs_run_length_kb = 100;
int par::ibs_run_missing = 2;
int par::ibs_run_0 = 1;
int par::ibs_inter_snp_distance = 1000000; // units=bp, 1=Mb
bool par::ibs_2only = false;

bool par::miss_run = false;
int par::miss_run_length = 100;
bool par::miss_run_length_kb = false;
double par::miss_run_level = 0.80;

bool par::FIXED = false;
Z par::FIX_IBD;
double par::FIX_p = 0.5;

bool par::matrix = false;
bool par::cluster = false;
bool par::cluster_missing = false;
bool par::cluster_selcon = false;
string par::cluster_selcon_file = "plink.clst";
int par::max_cluster_N = -1;
double par:: merge_p = 0.0005;
int par::ibstest_gap = 500000; // 500 kb
int par::max_cluster_size = 0;
int par::max_cluster_case = 0;
int par::max_cluster_control = 0;
bool par::cluster_on_phenotype = false;
bool par::cluster_on_mcc = false;
int par::min_neighbour = 1;
int par::max_neighbour = 10;
bool par::outlier_detection = false;
bool par::bmatch = false;
bool par::bmatch_usertype = false;
bool par::qmatch = false;
string par::bmatch_filename = "plink.bmatch";
string par::qmatch_filename = "plink.qmatch";
string par::bmatch_direction_filename = "plink.bm";
string par::qmatch_threshold_filename = "plink.qt";

bool par::include_cluster = false;
bool par::include_cluster_from_file = false;
string par::include_cluster_filename = "plink.clst";
int par::analyse_cluster = 0;

bool par::af_write = false;
bool par::af_count = false;
bool par::af_read = false;
bool par::inc_write = false;
bool par::inc_read = false;
string par::inc_file = "plink.inc";
string par::af_file = "plink.frq";

bool par::include_all_pairs = false;
double par::include_all_z1 = 0.001;

double par::MIN_PIHAT = 0.0025;
double par::MAX_PIHAT = 1.0000;
double par::MAX_CORR_PIHAT_PIHAT_G = 0.9;
double par::MAX_GENO_MISSING = 0.1;
double par::MAX_IND_MISSING = 0.1;
int par::MAX_LINE_LENGTH = 100000;

bool par::remove_indiv = false;
string par::remove_indiv_list = "plink.rem";
bool par::remove_keep_indiv = false;

int par::pp_maxsnp = 6;
int par::pp_maxfid = 6;
int par::pp_maxiid = 6;

int par::BATCH_SIZE = 500000;

bool par::plink = false;

